#! /usr/bin/python2

import string,sys,cgi
from Ft.Xml.Xslt import Processor
from Ft.Xml.InputSource import DefaultFactory
from Ft.Xml import InputSource

#-------------------------------------------------------------
# Testing 4Suite, parametric xslt
# Work on fixed files: all_results_x.xml and olymp_x.xslt
# Parameters are:
# sted (Barcelona or Atlanta) 
# distanse (100m or 200m or 400m) 
# B. Stenseth  2003
#-------------------------------------------------------------

def loadFile(fname):
    try:
        file=open(fname,'r')
        res=file.read()
        file.close()
        return res
    except:
        errorReturn('error reading: ' + fname)

def storeFile(fname,content):
    try:
        outf=open(fname,'w')
        outf.write(content)
        outf.close()
    except:
        print 'error writing'+ fname


def errorReturn(msg):
    T="""
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<META http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel="STYLESHEET" href="quest.css"/>
<title>errormsg</title>
</head>
<body>"""
    T+=msg
    T+="""
</body>
</html>
    """
    print T
    sys.exit('gir opp...')

def produce(place,distance):
    # fixed filenames 
    xmlfile='all_results_x.xml'
    xsltfile='olymp_x.xslt'
    htmlfile='result.html'
    xmlstr=loadFile(xmlfile)
    xsltstr=loadFile(xsltfile)

    processor=Processor.Processor()
    transform= DefaultFactory.fromString(xsltstr,"http://www.ia.hiof.no/~borres/cgi-bin/ftdemo/olymp_x.xslt")
    processor.appendStylesheet(transform)
    
    source= InputSource.DefaultFactory.fromString(xmlstr,"http://www.ia.hiof.no/~borres/cgi-bin/ftdemo/all_results_x.xml")

    params={'sted':place,'distanse':distance}
    result= processor.run(source,topLevelParams=params)

    print result
    
    # write it to file
    storeFile(htmlfile,result)
    try:
        outf=open(htmlfile,'w')
        outf.write(result)
        outf.close()
    except:
        print 'Error in writing'+ htmlfile


#-----------------------------------------
print "Content-type: text/html\n"
form=cgi.FieldStorage()

# what was thew question again ?
place=''
distance=''

try:
   place=form['1'].value
except:
   place='Barcelona'

try:
   distance=form['2'].value
except:
   distance='400m'


produce(place,distance)